﻿using System;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Text;
using Microsoft.Win32;
using SAE.J2534;

namespace E55ToolVZ
{
    class Program
    {

        // GOLBAL VARIABLES  *********************************************************************************************************************************************************************************************************************
        static bool connected = false;
        static bool VZseedkeyunlocked = false;
        static bool debug = false;


        // VARIABLES  *********************************************************************************************************************************************************************************************************************
        public static class Variable
        {
            public static String EcuVin;
            public static String EcuSystemCal;
            public static String EcuEngineCal;
            public static String EcuSoftwareVer;

            public static string DllFileName = APIFactory.GetAPIinfo().First().Filename;
            public static string DeviceName;
            public static SAE.J2534.Channel Channel;
            public static bool deviceselected = false;
            public static bool more = false;
            public static bool silencebus = false;
            public static int delay = 500;
            public static int sendcommandtimeout = 500;
            public static int startpin = 0;
            public static int PinEntry = 0;
            public static byte fails = 0;


        }


        // PROGRAM MAIN  *********************************************************************************************************************************************************************************************************************
        static void Main()
        {
            Console.WriteLine("\n\nE55Tool VZ V6 Tool V1.5\n");
            Console.WriteLine("*********************************************************");
            Console.WriteLine("Written By IronDuke & The1 pcmhacking.net");
            Console.WriteLine("J2534 dll used from https://github.com/BrianHumlicek" + " Modded By IronDuke\n");
            Console.WriteLine("If this Program Saved you Time/Money then Please Donate\n");
            Console.WriteLine("Paypal nigel@eyeit.org for Further Devs");
            Menu();
        }


        // MAIN MENU  *********************************************************************************************************************************************************************************************************************
        public static void Menu()
        {

            Console.WriteLine("\n*********************************************************");
            Console.WriteLine("**************  E55Tool VZ V6 Main Menu  ****************");
            Console.WriteLine("*********************************************************");
            Console.WriteLine("1 - ECU Bruteforce Pin Reset Menu");
            Console.WriteLine("2 - ECU/PIM Relink");
            Console.WriteLine("3 - Reset PIM");
            Console.WriteLine("4 - Write VIN");
            Console.WriteLine("5 - ECU Information");
            Console.WriteLine("6 - Advanced Menu");
            if (!VZseedkeyunlocked) Console.WriteLine("7 - Run ECU Seed/Key Unlock");
            else Console.WriteLine("7 - ECU is Seed/Key Unlocked");
            if (!connected) Console.WriteLine("8 - Connect to J2534 device");
            else Console.WriteLine($"8 - Disconnect from " + Variable.DeviceName + " J2534 device");
            if (!debug) Console.WriteLine("9 - Enable debug");
            else Console.WriteLine("9 - Disable debug");
            Console.WriteLine("10 - EXIT");
            Console.Write("\nEnter function to perform:");
            try
            {
                int choice = int.Parse(Console.ReadLine());

                //         if ((choice < 1) || (choice > 8)) Main();
                switch (choice)
                {
                    case 1:
                        {
                            resetpinmenu();
                            break;
                        }
                    case 2:
                        {
                            RelinkVZECU();
                            break;
                        }
                    case 3:
                        {
                            ResetPIMVZ();
                            break;
                        }
                    case 4:
                        {
                            WriteVIN();
                            break;
                        }
                    case 5:
                        {
                            ecuinfo();
                            break;
                        }
                    case 6:
                        {
                            advancedmenu();
                            break;
                        }
                    case 7:
                        {
                            VZSeedKey();
                            break;
                        }
                    case 8:
                        {
                            if (!connected) Connect();
                            else
                            {
                                connected = false;
                                APIFactory.StaticDispose(); // disconnect
                                Variable.deviceselected = false;
                            }
                            break;
                        }

                    case 9:
                        {
                            debug = !debug;
                            Menu();
                            break;
                        }
                    case 10:
                        {
                            Environment.Exit(0);
                            break;
                        }

                } // end of switch

                Menu();
            }
            catch (Exception)
            {
                // Console.WriteLine("Main Menu Error Occurred ");
                Main();// choice = 7;
            }
        }  // end of menu



        // RESET PIN MENU  **** Main Menu Option 1   *******************************************************************************************************************************************************************************************************
        public static void resetpinmenu()
        {
            Console.WriteLine("\n\n*********************************************************");
            Console.WriteLine("***********  ECU Bruteforce Pin Reset Menu  *************");
            Console.WriteLine("*********************************************************");
            Console.WriteLine($"1 - Retry Delay is {Variable.delay} ms");
            if (Variable.silencebus) Console.WriteLine("2 - Disable Silence Bus command");
            else Console.WriteLine("2 - Enable Silence Bus command");
            Console.WriteLine($"3 - Start at Pin {Variable.startpin}");
            Console.WriteLine("4 - Start Brute Forcing ECU Reset");
            Console.WriteLine("5 - Return to Main menu");

            try
            {
                int choice2 = int.Parse(Console.ReadLine());

                switch (choice2)
                {
                    case 1: // change delay
                        {
                            Console.WriteLine("Enter Delay in Milliseconds");
                            Variable.delay = int.Parse(Console.ReadLine());
                            break;
                        }
                    case 2:
                        {
                            Variable.silencebus = !Variable.silencebus;
                            break;
                        }
                    case 3:
                        {
                            Console.WriteLine("Enter Pin to start at");
                            Variable.startpin = int.Parse(Console.ReadLine());
                            break;
                        }

                    case 4:
                        {
                            Resetpin();
                            return;
                        }

                    case 5:
                        {
                            Menu();
                            break;
                        }

                }



            }
            catch
            {
                // Console.WriteLine("Brute Force Menu Error Occurred ");
                resetpinmenu();
            }
            resetpinmenu();

        }

        // RELINK ECU WITH PIN **** Main Menu Option 2   *********************************************************************************************************************************************************************************************
        public static void RelinkVZECU()
        {
            Console.WriteLine("\nPIM & ECU Must be Reset first, Press any key to Start");
            Console.Read();

            // Check Cable Connection
            if (!connected) Connect();

            //Request Seed Key Unlock
            VZSeedKey();

            // Change Filtering to 490
            Variable.Channel.ClearMsgFilters();
            Variable.Channel.StartMsgFilter(new MessageFilter(UserFilterType.PASS, new byte[] { 0x00, 0x00, 0x04, 0x90 }));
            Variable.Channel.ClearRxBuffer();

            // Run Relink Procedure
            Console.WriteLine("\n** Requesting PIM Relink with ECU **");
            Sendcommand(new byte[] { 0x00, 0x00, 0x02, 0x44, 0x02, 0x3B, 0x63, 0x55, 0x55, 0x55, 0x55, 0x55 }, Variable.sendcommandtimeout);

            System.Threading.Thread.Sleep(1000);

            GetMessageResults moremessage = Variable.Channel.GetMessages(1, Variable.sendcommandtimeout);
            string temp1 = BitConverter.ToString(moremessage.Messages[0].Data).Replace("-", "");

            Console.ForegroundColor = ConsoleColor.DarkYellow;
            if (debug) Console.WriteLine("DEBUG: SendMessage Response is " + temp1);
            Console.ForegroundColor = ConsoleColor.Gray;

            if (temp1.Length > 5) // needs to be long enough to get substring or it errors out.
            {
                // IF REPLY CONTAINS 7B63 Relink Success
                if (temp1.Contains("7B63"))
                {
                    Console.WriteLine("\n** ECU/PIM Relink Procedure Sucessful **");
                }
                else
                {
                    Console.WriteLine("\n** ECU/PIM Relink Procedure Failed **");
                }
            }
            else
            {
                Console.WriteLine("\n** ECU/PIM Relink Procedure Failed **");
            }
            // Change filtering back to 7e8
            Variable.Channel.ClearMsgFilters();
            Variable.Channel.StartMsgFilter(new MessageFilter(UserFilterType.PASS, new byte[] { 0x00, 0x00, 0x07, 0xE8 }));
            Variable.Channel.ClearRxBuffer();

            Console.WriteLine("\nPress any key to return to main menu");
            Console.Read();
            Main();

        }
        // RESET PIM **** Main Menu Option 3   *********************************************************************************************************************************************************************************************
        public static void ResetPIMVZ()
        {
            // Variable to store pin input
            byte[] Pin = new byte[4];

            // User input Pin
            Console.WriteLine("Input Current PIM Pin Code:");
            int input = int.Parse(Console.ReadLine());
            Pin = Encoding.ASCII.GetBytes(input.ToString("D4"));

            Console.ForegroundColor = ConsoleColor.DarkYellow;
            if (debug) Console.WriteLine($"DEBUG: Entered PIM Pin {Pin[0]:X} {Pin[1]:X} {Pin[2]:X} {Pin[3]:X}");
            Console.ForegroundColor = ConsoleColor.Gray;

            // Check Cable Connection
            if (!connected) Connect();

            // Change Filtering to 0644
            Variable.Channel.ClearMsgFilters();
            Variable.Channel.StartMsgFilter(new MessageFilter(UserFilterType.PASS, new byte[] { 0x00, 0x00, 0x06, 0x44 }));
            Variable.Channel.ClearRxBuffer();

            // Run PIM Reset Procedure
            Console.WriteLine("\n** Running PIM Reset Procedure **");

            // Unlock PIM with PIN
            String Response = Sendcommand(new byte[] { 0x00, 0x00, 0x02, 0x44, 0x06, 0x3B, 0x60, Pin[0], Pin[1], Pin[2], Pin[3], 0x55 }, Variable.sendcommandtimeout);

            Console.ForegroundColor = ConsoleColor.DarkYellow;
            if (debug) Console.WriteLine("DEBUG: SendMessage Response is " + Response);
            Console.ForegroundColor = ConsoleColor.Gray;

            if (Response.Length > 7) // needs to be long enough to get substring or it errors out.
            {
                // IF REPLY CONTAINS 
                if (Response.Contains("A4"))
                {
                    Console.WriteLine("\n** PIM Security Timer Lockout Enabled **");
                }
                else if (Response.Contains("3B78"))
                {
                    Console.WriteLine("\n** PIM Busy **");
                    Console.WriteLine("\n** Waiting **");
                    // Get more Messages as the Results wont be in the first Batch returned from PIM
                    GetMessageResults moremessage = Variable.Channel.GetMessages(1, Variable.sendcommandtimeout);
                    string temp1 = BitConverter.ToString(moremessage.Messages[0].Data).Replace("-", "");

                    Console.ForegroundColor = ConsoleColor.DarkYellow;
                    if (debug) Console.WriteLine("DEBUG: Response After PIM Busy is " + temp1);
                    Console.ForegroundColor = ConsoleColor.Gray;

                    if (temp1.Contains("6278"))
                    {
                        Console.WriteLine("\n** PIM Reset Successful **");
                    }
                    else if (temp1.Contains("6078"))
                    {
                        Console.WriteLine("\n** PIM Reset Successful **");
                    }
                    else
                    {
                        Console.WriteLine("\n** PIM Reset Failed **");
                    }
                }
                else if (Response.Contains("6078"))
                {
                    Console.WriteLine("\n** PIM Reset Successful **");
                }
                else
                {
                    Console.WriteLine("\n** PIM Reset Failed **");
                }
            }

            // Change filtering back to 7E8
            Variable.Channel.ClearMsgFilters();
            Variable.Channel.StartMsgFilter(new MessageFilter(UserFilterType.PASS, new byte[] { 0x00, 0x00, 0x07, 0xE8 }));
            Variable.Channel.ClearRxBuffer();

            Console.WriteLine("\nPress any key to return to main menu");
            Console.Read();
            Main();
        }


        // WRITE VIN **** Main Menu Option 4   ************************************************************************************************************************************************************************************************
        public static void WriteVIN()
        {
            // Variable to store pin input
            byte[] VIN = new byte[4];
            byte[] VIN1 = new byte[8];
            byte[] VIN2 = new byte[8];

            // User input VIN
            Console.WriteLine("Input VIN Digit 1-4:");
            VIN = Encoding.ASCII.GetBytes(Console.ReadLine());

            Console.WriteLine("Input VIN Digit 5-11:");
            VIN1 = Encoding.ASCII.GetBytes(Console.ReadLine());

            Console.WriteLine("Input VIN Digit 12-17:");
            VIN2 = Encoding.ASCII.GetBytes(Console.ReadLine());

            // Check Cable Connection
            if (!connected) Connect();

            //Request Seed Key Unlock
            VZSeedKey();

            // Run VIN Write Procedure
            Console.WriteLine("\n** Writing VIN **");
            String Response = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x10, 0x13, 0x3B, 0x90, VIN[0], VIN[1], VIN[2], VIN[3] }, Variable.sendcommandtimeout);
            Response = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x21, VIN1[0], VIN1[1], VIN1[2], VIN1[3], VIN1[4], VIN1[5], VIN1[6] }, Variable.sendcommandtimeout);
            Response = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x22, VIN2[0], VIN2[1], VIN2[2], VIN2[3], VIN2[4], VIN2[5] }, Variable.sendcommandtimeout);

            System.Threading.Thread.Sleep(50);

            if (Response.Contains("7F3B"))
            {
                Console.WriteLine("\n** ECU Busy **");

                // Get more Messages as the Results wont be in the first Batch returned from ECU
                GetMessageResults moremessage = Variable.Channel.GetMessages(1, Variable.sendcommandtimeout);
                string temp1 = BitConverter.ToString(moremessage.Messages[0].Data).Replace("-", "");

                if (temp1.Contains("7B90"))
                {
                    Console.WriteLine("\n** Writing VIN Successful **");
                }
            }
            else if (Response.Contains("7B90"))
            {
                Console.WriteLine("\n** Writing VIN Successful **");
            }
            else
            {
                Console.WriteLine("\n** Writing VIN Failed **");
            }

            Console.WriteLine("\nPress any key to return to main menu");
            Console.Read();
            Main();
        }


        // ECU INFORMATION **** Main Menu Option 5   ************************************************************************************************************************************************************************************************
        public static void ecuinfo()
        {

            if (!connected) Connect();
            Variable.Channel.ClearRxBuffer();

            // Software Version
            String SoftwareVer = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x02, 0x1A, 0xC1, 0x00, 0x00, 0x00, 0x00, 0x00 }, Variable.sendcommandtimeout);
            if (SoftwareVer.Contains("7F1A78")) // IF 7F Try again
            {
                SoftwareVer = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x02, 0x1A, 0xC1, 0x00, 0x00, 0x00, 0x00, 0x00 }, Variable.sendcommandtimeout);
            }
            Variable.EcuSoftwareVer = HexStringToString(SoftwareVer);
            Console.WriteLine("Software Version: " + Variable.EcuSoftwareVer.Remove(8, 1));
            System.Threading.Thread.Sleep(500);
            Variable.Channel.ClearRxBuffer();


            // Engine Calibration
            String EngineCal = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x02, 0x1A, 0xC2, 0x00, 0x00, 0x00, 0x00, 0x00 }, Variable.sendcommandtimeout);
            if (EngineCal.Contains("7F1A78")) // IF 7F Try again
            {
                EngineCal = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x02, 0x1A, 0xC2, 0x00, 0x00, 0x00, 0x00, 0x00 }, Variable.sendcommandtimeout);
            }
            Variable.EcuEngineCal = HexStringToString(EngineCal);
            Console.WriteLine("Engine Calibration: " + Variable.EcuEngineCal.Remove(8,1));
            System.Threading.Thread.Sleep(500);
            Variable.Channel.ClearRxBuffer();

            // System Calibration
            String SystemCal = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x02, 0x1A, 0xC3, 0x00, 0x00, 0x00, 0x00, 0x00 }, Variable.sendcommandtimeout);
            if (SystemCal.Contains("7F1A78")) // IF 7F Try again
            {
                SystemCal = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x02, 0x1A, 0xC3, 0x00, 0x00, 0x00, 0x00, 0x00 }, Variable.sendcommandtimeout);
            }
            Variable.EcuSystemCal = HexStringToString(SystemCal);
            Console.WriteLine("System Calibration: " + Variable.EcuSystemCal.Remove(8, 1));
            System.Threading.Thread.Sleep(500);
            Variable.Channel.ClearRxBuffer();

            // VIN
            String VIN = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x02, 0x1A, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00 }, Variable.sendcommandtimeout);
            if (VIN.Contains("7F1A78")) // IF 7F Try again
            {
                VIN = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x02, 0x1A, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00 }, Variable.sendcommandtimeout);
            }
            Variable.EcuVin = HexStringToString(VIN);
            Console.WriteLine("VIN: " + Variable.EcuVin);
            System.Threading.Thread.Sleep(500);
            Variable.Channel.ClearRxBuffer();

            Console.WriteLine("\nPress any key to return to main menu");
            Console.Read();
            Main();

        }
        // RELINK ECU WITH PIN **** Main Menu Option 6   *********************************************************************************************************************************************************************************************
        public static void advancedmenu()
        {

            Console.WriteLine("\n*********************************************************");
            Console.WriteLine("**************  E55Tool VZ V6 Advanced Menu  ************");
            Console.WriteLine("*********************************************************");
            Console.WriteLine("1 - Download RAM");
            Console.WriteLine("2 -"); //("2 - Download BIN");
            Console.WriteLine("3 -"); //("3 - Upload BIN");
            Console.WriteLine("4 - PID Request");
            Console.WriteLine("5 - Main Menu");
            Console.Write("\nEnter function to perform:");
            try
            {
                int choice = int.Parse(Console.ReadLine());

                //         if ((choice < 1) || (choice > 8)) Main();
                switch (choice)
                {
                    case 1:
                        {
                            downloadram();
                            break;
                        }
                    case 2:
                        {
                            //   downloadbin();
                            break;
                        }
                    case 3:
                        {
                            //  uploadbin();
                            break;
                        }
                    case 4:
                        {
                            pidrequest();
                            break;
                        }
                    case 5:
                        {

                            Menu();
                            break;
                        }

                } // end of switch

                advancedmenu();
            }
            catch (Exception)
            {
                // Console.WriteLine("Main Menu Error Occurred ");
                advancedmenu();// choice = 7;
            }
        }  // end of menu

        // Download RAM **** Advanced Menu Option 1   *********************************************************************************************************************************************************************************************
        public static void downloadram()
        {

            // User input Pin
            Console.WriteLine("\nWARNING: This Procedure will Read ECU RAM");
            Console.WriteLine("WARNING: This is not without Risks");
            Console.WriteLine("\nDo you wish to Proceed? Y/N :");
            string answer = Console.ReadLine();
            if (answer != "Y")
            {
                Console.WriteLine("\nPress any key to return to main menu");
                Main();
            }

            string savelocation;
            Console.WriteLine("\nEnter Save Location (*EG D:/Folder)");
            savelocation = Console.ReadLine();

            // Check Cable Connection
            if (!connected) Connect();

            //Request Seed Key Unlock
            VZSeedKey();

            // Variable to store pin input
            byte[] ramaddress = new byte[2];
            Console.WriteLine("\n** Downloading Ram Contents 0000 - FB1E to File **");

            // Buffer Storage for Data
            byte[] BytesOut = new byte[2032];
            byte[] TempBytesOut = new byte[512];

            int round = 0;
            string temp1 = "0000";
            string temp2 = "0000";

            for (int i = 0; i <= 279; i++)
            {
                // Sleep
                // System.Threading.Thread.Sleep(30);

                // Output Starting Read Address to Console
                temp1 = BitConverter.ToString(ramaddress);
                Console.WriteLine(temp1.Replace("-", ""));
                

                // Fetch Data Block Size FA
                String Response = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x07, 0x23, 0x00, 0x00, ramaddress[0], ramaddress[1], 0x00, 0xFA }, Variable.sendcommandtimeout);

                if (Response.EndsWith("60000000000000"))
                {
                    Console.ForegroundColor = ConsoleColor.DarkYellow;
                    if (debug) Console.WriteLine("DEBUG: Response 0160 Removing last 8 bytes");
                    Console.ForegroundColor = ConsoleColor.Gray;
                    Response.Remove(242, 14);

                }
                else if (Response.StartsWith("7F")) // DENIED RESPONSE, End of Ram Bank, Dump to File
                {
                    
                    Console.ForegroundColor = ConsoleColor.DarkYellow;
                    if (debug) Console.WriteLine("\n** Denied Reading Address Range, Dumping Buffer to File, Trying Next **");
                    Console.ForegroundColor = ConsoleColor.Gray;
                    
                    // Unlock ECU Again
                    VZSeedKey();

                    // Save Buffer to File
                    File.WriteAllBytes((savelocation+"/Ram_Segment_" + (temp2.Replace("-", ""))+"-"+(temp1.Replace("-", "")) + ".bin"), BytesOut);

                    // Increment to Next address
                    ramaddress[1] += 250;
                    ramaddress[0] += 1;

                    // inc min file
                    temp2 = BitConverter.ToString(ramaddress);

                    // Clear Round
                    round = 0;

                }
                else // Read and Store, every 8x FA reads it will be end of bank
                {

                    // Convert Stored Hex Values to Bytes, Store Output to Buffer, Remove 1st reply 8 bytes with address
                    TempBytesOut = ConvertHexToByteArray(Response.Remove(0,8));

                    for (int j = 0; j < TempBytesOut.Length; j++)
                    {

                        int byteno = (TempBytesOut.Length * round) + j;

                        // Add 
                        BytesOut[byteno] = TempBytesOut[j];

                    }

                    // Increment to Next address
                    ramaddress[1] += 250;
                    ramaddress[0] += 1;

                    // inc round
                    round++;

                }
            }

            Console.WriteLine("\n** Ram Download Success **");

            Console.WriteLine("\nPress any key to return to main menu");
            Console.Read();
        }

        // Download RAM **** Advanced Menu Option 4   *********************************************************************************************************************************************************************************************
        public static void pidrequest()
        {
            if (debug == false)
                debug = true;

            // Variable to store pin input
            byte[] PID = new byte[2];

            // User input Pin
            Console.WriteLine("Input PID to Request **EG: 90** :");
           int input = Convert.ToInt32(Console.ReadLine(), 16);
           PID[0] = Convert.ToByte(input);

            // Check Cable Connection
            if (!connected) Connect();

            //Request Seed Key Unlock
            VZSeedKey();

            System.Threading.Thread.Sleep(30);

            // Run Relink Procedure
            Console.WriteLine("\n** Requesting PID **");
            String Response = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x02, 0x1A, PID[0], 0x00, 0x00, 0x00, 0x00 }, Variable.sendcommandtimeout);

            if (Response.Contains("7F1A78"))
            {
                Console.WriteLine("\n** Didn't Work Trying Again **");

                Response = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x02, 0x1A, PID[0], 0x00, 0x00, 0x00, 0x00 }, Variable.sendcommandtimeout);

            }
            if (Response.Contains("60"))
            {
                Console.WriteLine("\n** Didn't Work Trying Again **");

                Response = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x02, 0x1A, PID[0], 0x00, 0x00, 0x00, 0x00 }, Variable.sendcommandtimeout);

            }


            Console.WriteLine("\nPress any key to return to main menu");
            Console.Read();
        }

             // SEND & RECEIVE MESSAGES   *********************************************************************************************************************************************************************************************************************
            public static string Sendcommand(byte[] Command, int Rtimeout)  // This is only for ECU 7E8 ecu.. will not respond correctly to other multiline messages.
        {
            int fails = 0;
            for (; ; )
                try
                {
                   // Variable.Channel.ClearRxBuffer();

                    Variable.Channel.SendMessage(Command); // what if we read til buffer empty like logging?

                    String Rmessage = "";
                    for (; ; )
                    {
                        GetMessageResults moremessage = Variable.Channel.GetMessages(1, Rtimeout);
                        if (moremessage.Result != ResultCode.BUFFER_EMPTY)
                        {
                            string temp1 = BitConverter.ToString(moremessage.Messages[0].Data).Replace("-", "");//.Remove(0, 8);
                            Console.ForegroundColor = ConsoleColor.DarkYellow;
                            if (debug) Console.WriteLine("DEBUG: GetMessage response is " + temp1);
                            Console.ForegroundColor = ConsoleColor.Gray;
                            if (temp1.Contains("000007E810"))
                            {
                                
                                Variable.Channel.SendMessage(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 });  // if message starts with a 10 that means you need to send a 30 to get the rest of the message
                                Variable.more = true;
                                Rmessage += temp1.Remove(0, 16);  // Leave only the DATA!

                            }
                            else // wasn't a 10.. read just 1 line and return
                            {
                                Rmessage += temp1.Remove(0, 10);  // Leave only the DATA!
                                if ((!Variable.more) && (!Rmessage.Contains("7F3478"))) break;  // if more flag is NOT set and Not ready flag is NOT set then break out of loop.. 
                                                                                                // if more flag is set then keep reading til buffer empty.. or if Not ready flag set then read 1 more line.. 
                            }
                            
                        }
                        else if (!Rmessage.Contains("7F3478"))
                        {
                            break;
                        }
                        else

                       Rmessage = Rmessage.Remove(0, 6); // if last message was 7f3478 this is not ready error, need to go back and read again.. 

                    }
                    Variable.more = false;

                    Console.ForegroundColor = ConsoleColor.DarkYellow;
                    if (debug) Console.WriteLine("DEBUG: SendMessage Response is " + Rmessage);
                    Console.ForegroundColor = ConsoleColor.Gray;

                    if (Rmessage == "")
                    {
                        Console.WriteLine("INFO: Buffer Empty No Response");
                    }
                    return Rmessage;
                    
                }
                catch (Exception Exception)
                {
                    fails++;
                    Console.WriteLine("Send Command Error: {0}", Exception.Source);
                    if (fails > 5)
                    {

                        APIFactory.StaticDispose();
                        Variable.deviceselected = false;
                        connected = false;

                        Console.WriteLine("Press any key to exit.");
                        Console.ReadKey();

                        Environment.Exit(0);
                        return null;
                    }
                  

                }

        } // end of sendcommand


// ONLY SEND MESSAGES   *********************************************************************************************************************************************************************************************************************
        public static string Senddata(byte[] Command)
        {
            int fails = 0;
            for (; ; )
            {
                try
                {
                   // if (debug) Console.WriteLine("DEBUG: " + BitConverter.ToString(Command).Replace("-", ""));
                    Variable.Channel.SendMessage(Command); // what if we read til buffer empty like logging?
                    return null;
                }
                catch (Exception Exception)
                {
                    fails++;
                    Console.WriteLine("Send Data Exception #" + fails + " Error source: {0}", Exception.Source);
                    if (fails > 5)
                    {
                        Console.WriteLine("Press any key to exit.");
                        Console.ReadKey();
                        APIFactory.StaticDispose();
                        Variable.deviceselected = false;
                        connected = false;
                        Main();
                        return null;
                    }
                    // else break;
                }
            }

        }


// CONVERT HEX TO STRING   *********************************************************************************************************************************************************************************************************************
        public static string HexStringToString(string HexString)
        {
            string stringValue = "";
            for (int i = 0; i < HexString.Length / 2; i++)
            {
                string hexChar = HexString.Substring(i * 2, 2);
                int hexValue = Convert.ToInt32(hexChar, 16);
                stringValue += Char.ConvertFromUtf32(hexValue);
            }
            return stringValue;
        }  // end HexStringToString

// CONVERT STRING HEX TO BYTE ARRAY  *********************************************************************************************************************************************************************************************************************
        public static byte[] ConvertHexToByteArray(string hexString)
        {
            byte[] byteArray = new byte[hexString.Length / 2];

            for (int index = 0; index < byteArray.Length; index++)
            {
                string byteValue = hexString.Substring(index * 2, 2);
                byteArray[index] = byte.Parse(byteValue, NumberStyles.HexNumber, CultureInfo.InvariantCulture);
            }

            return byteArray;
        }


        // RESET PIN PROCEDURE   *********************************************************************************************************************************************************************************************************************
        public static void Resetpin()
        {

            if (!connected) Connect();

            Variable.Channel.ClearRxBuffer();

            byte[] key = new byte[4];
            Variable.fails = 0;
            Console.WriteLine("\n** Attempting to Unlock ECU **");
            for (int k = Variable.startpin; k < 10000; k++)
            {
                
                key = Encoding.ASCII.GetBytes(k.ToString("D4"));

                Console.ForegroundColor = ConsoleColor.DarkYellow;
                if (debug) Console.WriteLine($"DEBUG: Trying {key[0]:X} {key[1]:X} {key[2]:X} {key[3]:X}");
                Console.ForegroundColor = ConsoleColor.Gray;

                string response = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x07, 0xAE, 0x7D, 0x08, key[0], key[1], key[2], key[3] }, Variable.sendcommandtimeout);

                if (response.Length > 5) // needs to be long enough to get substring or it errors out.
                {
                    // IF REPLY CONTAINS EE 7D REPLY UNLOCKED
                    if (response.Contains("EE7D"))
                    {
                        if (Variable.startpin == k)
                            Console.Write("\nECU ALREADY UNLOCKED :)\n");
                        else
                        Console.Write($"    Unlocked with PIN: {k:D4} ");
                        break;
                    }
                    else
                    {
                        Console.WriteLine($"Failed Unlock with Pin: {k:D4}");

                        if (response.Contains("A4")) // correct response for timer lockout enabled
                        {
                            Console.ForegroundColor = ConsoleColor.DarkYellow;
                            if (debug) Console.WriteLine("DEBUG: Response A4 Resetting Timer, Retry Pin");
                            Console.ForegroundColor = ConsoleColor.Gray;
                            Senddata(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x03, 0xAE, 0x7D, 0x02, 0x00, 0x00, 0x00, 0x00 }); // reset timer
                            System.Threading.Thread.Sleep(Variable.delay);
                            Variable.Channel.ClearRxBuffer();
                            k--;
                        }
                        else
                        if (response.Contains("A2")) // reponse for pin failed
                        {
                            Console.ForegroundColor = ConsoleColor.DarkYellow;
                            if (debug) Console.WriteLine("DEBUG: Response A2 Trying Next Pin");
                            Console.ForegroundColor = ConsoleColor.Gray;
                            System.Threading.Thread.Sleep(Variable.delay);
                        }
                        else
                        if (response.Contains("68")) // response for Silence Enabled
                        {
                            Console.ForegroundColor = ConsoleColor.DarkYellow;
                            if (debug) Console.WriteLine("DEBUG: Response 68 to Silence Retry Pin");
                            Console.ForegroundColor = ConsoleColor.Gray;
                            System.Threading.Thread.Sleep(Variable.delay);
                            Variable.Channel.ClearRxBuffer();
                            k--;
                        }
                        else
                        if (response.Contains("0160")) 
                        {
                            Console.ForegroundColor = ConsoleColor.DarkYellow;
                            if (debug) Console.WriteLine("DEBUG: Response 0160 Retry Pin");
                            Console.ForegroundColor = ConsoleColor.Gray;
                            System.Threading.Thread.Sleep(Variable.delay);
                            Variable.Channel.ClearRxBuffer();
                            k--;
                        }
                        else
                        {
                            Console.WriteLine($"wrong response of {response} Exiting..");
                            Variable.fails++;
                           
                            System.Threading.Thread.Sleep(Variable.delay);
                            if (Variable.fails > 5)
                            {
                                Console.ForegroundColor = ConsoleColor.Red;
                                Console.WriteLine("*Too Many Errors*");
                                Console.ForegroundColor = ConsoleColor.White;
                                break;
                            }

                        }

                        if (k % 5 == 0) // every 5 keys send tool present and silencebus bus if requested.
                        {
                            Console.ForegroundColor = ConsoleColor.DarkYellow;
                            if (debug) Console.WriteLine("DEBUG: Sending Silence Command");
                            Console.ForegroundColor = ConsoleColor.Gray;
                            Senddata(new byte[] { 0x00, 0x00, 0x07, 0xDF, 0x01, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 });
                            System.Threading.Thread.Sleep(30); 
                            if (Variable.silencebus) Senddata(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x01, 0x28, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }); // silencebus bus command
                            System.Threading.Thread.Sleep(30); 
                            Variable.Channel.ClearRxBuffer();
                            System.Threading.Thread.Sleep(30); 
                        }
                    }
                }
            }
            Console.WriteLine("\nPress any key to Return to Main Menu");
            Console.Read();
            Main();
        }

        // SEED KEY PROCEDURE for OB Algo ************************************************************************************************************************************************************************************************************
        public static void VZSeedKey()
        {
            // Variables
            Byte[] ecukey = new byte[2];
            Int32 Key = 0;

            // Check Cable Connection
            if (!connected) Connect();

            // Send Seed Request
            String Response = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x02, 0x27, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00 }, Variable.sendcommandtimeout);
            
            if (Response.Contains("6701")) // correct response for seed request
            {
                
                //Convert Reply String as DEC to HEX
                Key = int.Parse(Response[4].ToString() + Response[5].ToString() + Response[6].ToString() + Response[7].ToString(), System.Globalization.NumberStyles.HexNumber);

                // Debug
                Console.ForegroundColor = ConsoleColor.DarkYellow;
                if (debug) Console.WriteLine($"DEBUG: Seed Received DEC: " + Key + " HEX: " + Response[4] + Response[5] + Response[6] + Response[7]);
                Console.ForegroundColor = ConsoleColor.Gray;

                // Process Seed to Get Key
                // &H98 Sub LLHH
                if (Key < (0x3808))
                    Key += 0x10000;

                Key -= 0x3808;

                // &H7E Byte Swap Then If LL>HH ADD LLHH Else ADD HHLL
                Key = (Key << 8 & 0xFF00) | (Key >> 8 & 0xFF);
                Key += 0xF294;
                Key = Key & 0xFFFF;

                // &H6B Rotate Right by HH bits
                Key = (Key >> 02) | (Key << 14);
                Key = Key & 0xFFFF;

                // &H4C Rotate Left by LL bits
                Key = (Key << 03) | (Key >> 13);
                Key = Key & 0xFFFF;

                //Convert Int32 key to hex Byte
                ecukey[0] = Convert.ToByte((Key & 0xFF00) >> 8);
                ecukey[1] = Convert.ToByte(Key & 0x00FF);

                //Debug
                Console.ForegroundColor = ConsoleColor.DarkYellow;
                if (debug) Console.WriteLine($"DEBUG: Calculated ECU Unlock Key DEC: " + Key + " HEX: "+ BitConverter.ToString(ecukey).Replace("-", ""));
                Console.ForegroundColor = ConsoleColor.Gray;

                // Send Seed Request
                String SendKey = Sendcommand(new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x04, 0x27, 0x02, ecukey[0], ecukey[1], 0x00, 0x00, 0x00 }, Variable.sendcommandtimeout);

                //Debug
                Console.ForegroundColor = ConsoleColor.DarkYellow;
                if (debug) Console.WriteLine("DEBUG: ECU Reply to Seed " + SendKey);
                Console.ForegroundColor = ConsoleColor.Gray;

                Variable.Channel.ClearRxBuffer();

                if (SendKey.Contains("6702")) // correct response for ecu unlocked
                {

                    VZseedkeyunlocked = true;
                    Console.WriteLine("\nSeed/Key Unlock Successful");
                }
                else
                {
                    VZseedkeyunlocked = false;
                    Console.WriteLine("\nSeed/Key Unlock Failed");
                }
              }
           
            }
            // LIST OUT DEVICES  *********************************************************************************************************************************************************************************************************************
            public static void SelectJ2534()
            {
                for (int c = 1; c <= APIFactory.GetAPIinfo().Count(); c++)
                {
                    Console.WriteLine(c + " - " + APIFactory.GetAPIinfo().ElementAt(c - 1).Name);

                }

                Console.Write("\nInput Device Number:");
                int index = 0;

                try { index = Convert.ToInt32(Console.ReadLine()); }
                catch { index = 1; }
                if ((index > APIFactory.GetAPIinfo().Count()) | (index < 1)) index = 1;

                Variable.DllFileName = APIFactory.GetAPIinfo().ElementAt(index - 1).Filename;
                Variable.DeviceName = APIFactory.GetAPIinfo().ElementAt(index - 1).Name;
                Variable.deviceselected = true;

            }


            // CONNECTION TO CABLE   *********************************************************************************************************************************************************************************************************************
            public static void Connect()
            {
                try
                {
                    Console.WriteLine("*********************************************************");
                    Console.WriteLine("\nSelect Device:");
                    Console.WriteLine("*********************************************************");

                if (!Variable.deviceselected) SelectJ2534();
                    Variable.Channel = APIFactory.GetAPI(Variable.DllFileName).GetDevice().GetChannel(Protocol.CAN, Baud.CAN, ConnectFlag.CAN_ID_BOTH);
                    Variable.Channel.StartMsgFilter(new MessageFilter(UserFilterType.PASS, new byte[] { 0x00, 0x00, 0x07, 0xE8 }));
                    Variable.Channel.DefaultTxTimeout = 500;
                    Variable.Channel.DefaultRxTimeout = 500;
                    connected = true;

                    Console.ForegroundColor = ConsoleColor.DarkYellow;
                    if (debug) Console.WriteLine("DEBUG: Using DLL: " + Variable.DllFileName);
                    if (debug) Console.WriteLine("DEBUG: Cable Connected: " + Variable.deviceselected);
                    Console.ForegroundColor = ConsoleColor.Gray;
                }

                catch (Exception Exception)
                {
                    Console.WriteLine("\nError Connecting");
                    Console.ForegroundColor = ConsoleColor.DarkYellow;
                    if (debug) Console.WriteLine("\nException Error source: {0}", Exception.Source);
                    Console.ForegroundColor = ConsoleColor.Gray;

                    APIFactory.StaticDispose(); // disconnect
                    Variable.deviceselected = false;
                    connected = false;

                    Console.WriteLine("Press any key to exit.");
                    Console.ReadKey();

                Environment.Exit(0);
                }


            } // end of Connect
        }
}
